#// frame.awk
#// Dynamic frame for the viewer
#// 17.04.2015
#// 
#// Copyright (C) 2015  Balthasar Szczepański
#// 
#// This program is free software: you can redistribute it and/or modify
#// it under the terms of the GNU Affero General Public License as
#// published by the Free Software Foundation, either version 3 of the
#// License, or (at your option) any later version.
#// 
#// This program is distributed in the hope that it will be useful,
#// but WITHOUT ANY WARRANTY; without even the implied warranty of
#// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#// GNU Affero General Public License for more details.
#// 
#// You should have received a copy of the GNU Affero General Public License
#// along with this program.  If not, see <http://www.gnu.org/licenses/>.

BEGIN{
	FS=""
	framepath="/eizm/www/time/"
	datapath="/eizm/data/aftertime/"
	
	if(frame ~ /[a-zA-Z]$/)
	{
		f=int(substr(frame,1,length(frame)-1))
		s=substr(frame, length(frame))
	}
	else
	{
		f=int(frame)
		s=""
	}
	e=int(enhance)
	
	lastalt=0
	
	ch2num[0]=""
	num2ch[""]=0
	for(i=1;i<=26;++i)
	{
		ch=sprintf("%c",i+96)
		num2ch[i]=ch
		ch2num[ch]=i
	}
}
{
	file=1
	gsub(/[\r\n]/, "", $0)
	eq=index($0, "=")
	
	if($0 ~ /^sf-[0-9]+=/)
	{
		sf=1
		i=int(substr($0, 4, eq-4))
		if(i==f)
			this_sf= tolower(substr($0, eq+1))
		if(i==f-1)
			prev_sf=tolower(substr($0, eq+1))
			
	}
	argtab[substr($0, 1, eq-1)]=substr($0, eq+1)
}
END{
	
	if (file=="")
		exit 1
	
	if(this_sf=="")
		s=""
	else if(s>this_sf && argtab["cfrt"]=="")
		s=this_sf
	
	ongoing=int(argtab["ongoing"])
	if(ongoing>0)
	{
		statefile= datapath argtab["story"]"/ongstate"
		getline temp < statefile
		close(statefile)
		
		split(temp, temptab, " ")
		state=int(temptab[1])
		last=int(temptab[2])
	}
	else
	{
		last=int(argtab["last"])
		state=3
	}
	first=int(argtab["first"])
	
	if(frame=="")
	{
		if(ongoing>0)
		{
			f=last
			onlyframe=1
		}
		else
		{
			f=first
			onlyframe=""
		}
	}
	
	if(f<first && argtab["cfrt"]=="")
		f=first
	
	if(f>last && argtab["cfrt"]=="")
		f=last
	
	framedir= (argtab["framedir"]!="" ? argtab["framedir"] : "/aftertime/"argtab["story"]"/")
	if(sf!="")
	{
		frame= framedir sprintf(argtab["frame"(e>0 ? "-"e : "")],f,s)
		if (system("[ -f " framepath frame" ]")!=0)
			frame= framedir sprintf(argtab["frame"],f,s)
	}
	else
	{
		s=""
		frame= framedir sprintf(argtab["frame"(e>0 ? "-"e : "")],f)
		if (system("[ -f " framepath frame" ]")!=0)
			frame=framedir sprintf(argtab["frame"],f)
	}
	
	if(f==last && state==1)
	{
		print "2 "f > statefile
		close (statefile)
	}
	
	if((f>last || f<first || (this_sf!="" && s>this_sf)) || state==0 && argtab["cfrt"]!="")
		frame= framedir argtab["cfrt"]
	
	if(state==0 && argtab["cfrt"]=="")
	{
		print "Status: 404 Not Found"
		print ""
	}
	
	print "Status: 302 Temporal Relocation"
	print "Location: "frame
	print ""

}
