#// ong-mscha-t-1.awk
#// The bot to ketchup frames from the mschaviewer, and enhance by remapping
#// 16.09.2015
#// 
#// Copyright (C) 2015  Balthasar Szczepański
#// 
#// This program is free software: you can redistribute it and/or modify
#// it under the terms of the GNU Affero General Public License as
#// published by the Free Software Foundation, either version 3 of the
#// License, or (at your option) any later version.
#// 
#// This program is distributed in the hope that it will be useful,
#// but WITHOUT ANY WARRANTY; without even the implied warranty of
#// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#// GNU Affero General Public License for more details.
#// 
#// You should have received a copy of the GNU Affero General Public License
#// along with this program.  If not, see <http://www.gnu.org/licenses/>.
#//
BEGIN{
	FS=""
	framepath="/eizm/www/time/"
	datapath="/eizm/data/aftertime/"
	temppath="/eizm/tmp/aftertime/"
	
	# timecmd="date +\"%H\""
	
	cp="/bin/cp"
	mawk="/usr/bin/mawk"
	wget="/usr/bin/wget"
	remap="/eizm/pro/aftertime/remapt-1"
	npb="/eizm/pro/ong1/npb"
	bot4awk="/eizm/pro/aftertime/bot4.awk"
}
{
	file=1
	gsub(/[\r\n]/, "", $0)
	eq=index($0, "=")
	
	argtab[substr($0, 1, eq-1)]=substr($0, eq+1)
}
END{
	
	if (file=="")
		exit 1
	
	if(argtab["ongoing"]!="2")
		exit 1
	
	# timecmd | getline thistime
		# close(timecmd)
	
	statefile= datapath argtab["story"]"/ongstate"
	getline temp < statefile
	getline alt < statefile
	close(statefile)
	
	split(temp, temptab, " ")
	state=int(temptab[1])
	last=int(temptab[2])
	
	f=last+1
	
	nextstate="2"
	
	tempfile = temppath "ongmscha-"argtab["story"]
	optionfile = datapath argtab["story"]"/settings"
	framedir = "aftertime/"argtab["story"]"/"
	
	while(1)
	{
		newalt=""
		frameurl= sprintf(argtab["otherviewerframe"],f)
		viewerurl= sprintf(argtab["otherviewerurl"],f)
		
		frame= framepath framedir sprintf(argtab["frame"],f)
		npbframe= framepath framedir sprintf(argtab["npbframe"],f)
		
		remapframe= framepath framedir sprintf(argtab["frame-1"],f)
		npbremapframe= framepath framedir sprintf(argtab["npbframe-1"],f)
		
		getfcmd= wget " -q -O " frame " "frameurl
		getvcmd= wget " -q -O " tempfile " "viewerurl
		npbcmd= sprintf(npb " %s %s q",frame,npbframe)
		ongcmd= mawk" -f " bot4awk" -v story="argtab["story"]" -v frame="last" "optionfile
		ongremapcmd= mawk" -f " bot4awk" -v story="argtab["story"]" -v frame="last" -v enhance=1 "optionfile
		npbremapcmd= sprintf(npb " %s %s q",remapframe,npbremapframe)
		
		# print getfcmd
		if(system(getfcmd)!=0)
			break
		system("sleep 5")
		
		# print getvcmd
		if(system(getvcmd)!=0)
			break
		system("sleep 1")
		
		foundalt=""
		foundpal=""
		while ((getline temp < tempfile) > 0)
		{
			if(index(temp,frameurl)!=0 && foundalt=="")
			{
				newalt=substr(temp,index(temp,"title=\"")+7)
				newalt=substr(newalt,1,index(newalt,"\"")-1)
				foundalt=1
			}
			if(index(temp,"class=\"hash\"")!=0 && foundpal=="" )
			{
				pal=substr(temp,index(temp,">")+1)
				pal=substr(pal,1,index(pal,".")-1)
				foundpal=1
			}
			if(foundalt!="" && foundpal!="")
				break;
		}
		close(tempfile)
		# if(newalt=="")
			# break
		
		remapcmd= remap " "frame" "remapframe" "pal
		
		if(newalt!=alt)
		{
			print f"="newalt >> optionfile
			close(optionfile)
		}
		
		# print npbcmd
		if(system(npbcmd)!=0)
			break
		
		last=f
		print "ONG "f" "((alt==newalt)?"":""newalt)
		
		#print remapcmd
		if(system(remapcmd)==0)
		{
			if(system(npbremapcmd)!=0)
				break
		}
		
		
		if (post!="")
		{
			system(ongcmd)
			system("sleep 5")
			system(ongremapcmd)
		}
		
		alt=newalt
		
		print nextstate" "f > statefile
		print newalt > statefile
		close(statefile)
		
		++f
	}
}
