#// upload.awk
#// The post upload interface
#// 16.09.2015
#// 
#// Copyright (C) 2015  Balthasar Szczepański
#// 
#// This program is free software: you can redistribute it and/or modify
#// it under the terms of the GNU Affero General Public License as
#// published by the Free Software Foundation, either version 3 of the
#// License, or (at your option) any later version.
#// 
#// This program is distributed in the hope that it will be useful,
#// but WITHOUT ANY WARRANTY; without even the implied warranty of
#// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#// GNU Affero General Public License for more details.
#// 
#// You should have received a copy of the GNU Affero General Public License
#// along with this program.  If not, see <http://www.gnu.org/licenses/>.

BEGIN{
	postpath="/eizm/mem/aftertime/mpost/"
	passpath="/eizm/mem/aftertime/pass/"
	rmpath="/eizm/mem/aftertime/rm/"
	bb2html="/eizm/pro/aftertime/bb2html.awk"
	automome="/eizm/pro/ong1/mome.pl"
	memepath="/eizm/mem/ong1/mome.txt"
	timecmd="date -u +\"%s\""
	
	timecmd | getline thistime
		close(timecmd)
	
	srand(int(thistime) + int( PROCINFO["pid"]))
	
	for(i=0;i<256;++i)
	{
		ch=sprintf("%c",i)
		hex=sprintf("%02X",i)
		hexl=sprintf("%02x",i)
		dec=sprintf("%u",i)
		ch2hex[ch]=hex
		hex2ch[hex]=ch
		ch2hexl[ch]=hexl
		ch2dec[ch]=dec
	}
	
	# year=substr(timetext,1,4)
	# month=substr(timetext,5,2)
	# day=substr(timetext,7,2)
	# hour=substr(timetext,9,2)
	
	# yyy=year+0
	# mmm=month+0
	# ddd=day+0
	# hhh=hour+0
	
	ln=0
}
{
	gsub(/[\r\n]/,"",$0)
	if (FNR==1)
	{
		name=$0
		# print "username: "name
		next
	}
	if (FNR==2)
	{
		pass=$0
		gsub(/./,"*", $0)
		# print "password: "$0
		next
	}
	
	if($0=="")
	{
		if(ln!=0)
		{
			post()
			ln=0
			nobb=""
			nosmil=""
			nourl=""
			quot=""
			rmov=""
			lst=""
			h=""
			d=""
			m=""
			y=""
			subject=""
			content=""
			options=""
			story=""
			frame=""
			round=""
			idtab[1]=""
			idtab[2]=""
			idtab[3]=""
		}
		next
	}
	
	++ln
	if(ln==1)
	{
		if($0 ~ /#/)
			split($0, idtab, "#")
		else
			split($0, idtab, "-")
		story=idtab[1]
		frame=int(idtab[2])
		round=int(idtab[3])
	}
	else if(ln==2)
	{
		options=tolower($0)
		if(options ~ /b/)
			nobb=1
		if(options ~ /s/)
			nosmil=1
		if(options ~ /u/)
			nourl=1
		if(options ~ /r/)
			rmov=1
		if(options ~ /q/)
			quot=1
		if(options ~ /l/)
			lst=1
	}
	else if(ln==3)
	{
		y=substr($0,1,4)
		m=substr($0,6,2)
		d=substr($0,9,2)
		h=substr($0,12,2)
	}
	
	else if(ln==4)
	{
		subject=$0
	}
	else
	{
		if(ln!=5)
			content=content "\n" $0
		else
			content=$0
	}

}
END{
	if(ln!=0)
		post()
}
function remove(   postid,postfile,rmfile,passfile,temp,f,tn,eq,tv,namef,passf)
{
	postid=sprintf("%s-%04u-%02u",story,frame,round)
	postfile=postpath postid
	rmfile=rmpath postid
	passfile=passpath story
	printf("%s",postid" ")
	
	getline namef < passfile
	getline passf < passfile
	close (passfile)
	gsub(/[\r\n]/,"",namef)
	gsub(/[\r\n]/,"",passf)
	
	if(name!=namef)
	{
		print "Can't remove. Wrong username."
		return
	}
	if(pass!=password)
	{
		print "Can't remove. Wrong password."
		return
	}
	
	if(system("mv -f "postfile" "rmfile)==0)
	{
		print "removed."
		return
	}
	print "not removed."
}

function quote(   postid,postfile,passfile,temp,f,opt,cont,ongt,subj,eq,tn,tv,id,namef,passf,yy,mm,dd,hh)
{
	postid=sprintf("%s-%04u-%02u",story,frame,round)
	postfile=postpath postid
	passfile=passpath story
	
	getline namef < passfile
	getline passf < passfile
	close (passfile)
	gsub(/[\r\n]/,"",namef)
	gsub(/[\r\n]/,"",passf)
	
	if((name!=namef)||(pass!=passf))
	{
		print "Can't quote."
		return
	}
	
	while((getline temp < postfile)>0)
	{
		f=1
		gsub(/[\r\n]/,"",temp)
		eq=index(temp,"=")
		tn=substr(temp,1,eq-1)
		tv=substr(temp,eq+1)
		
		if(tn=="BB")
			cont=unhtml(tv)
		else if(tn=="brtext")
			ongt=tv
		else if(tn=="y")
			yy=tv
		else if(tn=="m")
			mm=tv
		else if(tn=="d")
			dd=tv
		else if(tn=="h")
			hh=tv
		else if(tn=="subject_h")
			subj=unhtml(tv)
		else if(tn=="ID")
			id=tv
		else if(tn=="disable_bbcode")
		{
			if(tv=="on")
				opt=opt"B"
		}
		else if(tn=="disable_smilies")
		{
			if(tv=="on")
				opt=opt"S"
		}
		else if(tn=="disable_magic_url")
		{
			if(tv=="on")
				opt=opt"U"
		}
	}
	if(f!="")
	{
		close(postfile)
		if (opt=="")
			opt="_"
		print postid" subject "subj
		print postid" options "opt
		print postid" time "sprintf("%04u-%02u-%02u %02u:00",yy,mm,dd,hh)
		print postid" content "((ongt!="")?ongt:cont)
		if(id!="")
			print postid" ID "id
		return
	}
	
	else
		print postid " can't quote." #I shouldn't tell why
}

function list(   cmd,id,postfile,passfile,temp,mt,f,eq,tn,tv,namef,passf,yy,mm,dd,hh)
{
	
	passfile = passpath story
	
	getline namef < passfile
	getline passf < passfile
	close (passfile)
	gsub(/[\r\n]/,"",namef)
	gsub(/[\r\n]/,"",passf)
	
	if((name!=namef)||(pass!=passf))
		return
	
	cmd="/bin/ls -1 --color=never "postpath
	while ((cmd | getline id)>0)
	{
		f=""
		mt="^"story"-"
		if(id !~ mt)
			continue
		postfile = postpath id
		
		while((getline temp < postfile)>0)
		{
			f=1
			gsub(/[\r\n]/,"",temp)
			eq=index(temp,"=")
			tn=substr(temp,1,eq-1)
			tv=substr(temp,eq+1)
			if(tn=="y")
				yy=tv
			else if(tn=="m")
				mm=tv
			else if(tn=="d")
				dd=tv
			else if(tn=="h")
				hh=tv
		
		}
		if(f!="")
		{
			close(postfile)
			print id" time "sprintf("%04u-%02u-%02u %02u:00",yy,mm,dd,hh)
		}
	}
	close (cmd)
}

function post(   postid,replaceid,postfile,passfile,replacefile,temp,i,eq,tn,tv,namef,passf,key,id)
{
	if(lst!="")
		return list()
	if(quot!="")
		return quote()
	if(rmov!="")
		return remove()
	postid=sprintf("%s-%04u-%02u",story,frame,round)
	printf("%s",postid" ")
	
	postfile=postpath postid
	passfile = passpath story

	
	if(options=="")
	{
		print "No options defined."
		return
	}
	
	if (name=="")
	{
		print "Username missing."
		return
	}
	if (pass=="")
	{
		print "Password missing."
		return
	}
	if (story=="")
	{
		print "Story name missing."
		return
	}
	if(story !~ /^(t1i|bftf)$/)
	{
		print "Unknown story."
		return
	}
	if (frame=="")
	{
		print "Frame number missing."
		return
	}
	if (round=="")
	{
		print "Round number missing."
		return
	}
	if (subject=="")
	{
		print "Subject missing."
		return
	}
	if (content=="")
	{
		print "Post is empty."
		return
	}
	
	yy=y+0
	mm=m+0
	dd=d+0
	hh=h+0
	
	getline namef < passfile
	getline passf < passfile
	close (passfile)
	gsub(/[\r\n]/,"",namef)
	gsub(/[\r\n]/,"",passf)
	
	if(name!=namef)
	{
		print "Wrong username."
		return
	}
	if(pass!=passf)
	{
		print "Wrong password."
		return
	}
	
	split("", ongtable, ":")
	while((getline temp < postfile)>0)
	{
		gsub(/[\r\n]/,"",temp)
		eq=index(temp,"=")
		tn=substr(temp,1,eq-1)
		tv=substr(temp,eq+1)
		
		if(tn ~ /^[ou]ngd?-[0-9]+$/)
		{
			ongtable[tn]=brunescape(tv)
		}
		else if(tn == "key")
			key=tv
		else if(tn == "ID")
			id=tv
		
	}
	close(postfile)
		
	printf("")>postfile
	
	print "timenumber="htmlescape(postid) >> postfile
	print "key="(key==""?newkey():key) >> postfile
	print "username_h="htmlescape(name) >> postfile
	print "subject_h="htmlescape(subject) >> postfile
	print "story="story >> postfile
	print "frame="sprintf("%04u",frame) >> postfile
	print "round="sprintf("%02u",round) >> postfile
	
	print "h="htmlescape(h) >> postfile
	print "d="htmlescape(d) >> postfile
	print "m="htmlescape(m) >> postfile
	print "y="htmlescape(y) >> postfile
	
	if(nobb!="")
		print "disable_bbcode=on" >> postfile
	if(nosmil!="")
		print "disable_smilies=on" >> postfile
	if(nourl!="")
		print "disable_magic_url=on" >> postfile
	
	
	
	print "brtext="brescape(content) >> postfile
	
	gsub(/\[br\]/,"\n",content)
	
	for(i=0; content~/\[ong\]/; ++i)
	{
		tn=sprintf("ong-%u",i)
		ongtext = ongtable[tn]
		if (ongtext == "")
			ongtext=ong()
		print(tn"="brescape(ongtext)) >> postfile
		sub(/\[ong\]/,subescape(ongtext),content)
	}
	for(i=0; content~/\[ung\]/; ++i)
	{
		tn=sprintf("ung-%u",i)
		ongtext = ongtable[tn]
		if (ongtext == "")
			ongtext=ung()
		print(tn"="brescape(ongtext)) >> postfile
		sub(/\[ung\]/,subescape(ongtext),content)
	}
	for(i=0; content~/\[ong=decree\]/; ++i)
	{
		tn=sprintf("ongd-%u",i)
		ongtext = ongtable[tn]
		if (ongtext == "")
			ongtext=ong("decree")
		print(tn"="brescape(ongtext)) >> postfile
		sub(/\[ong=decree\]/,subescape(ongtext),content)
	}
	for(i=0; content~/\[ung=decree\]/; ++i)
	{
		tn=sprintf("ungd-%u",i)
		ongtext = ongtable[tn]
		if (ongtext == "")
			ongtext=ung("decree")
		print(tn"="brescape(ongtext)) >> postfile
		sub(/\[ung=decree\]/,subescape(ongtext),content)
	}
	
	# print "content:\n"content
	print "BBHTML="htmlescape(content,"","br") >> postfile
	print "BB="htmlescape(content,"less","br") >> postfile
	print "message="urlencode(content ((silent=="")?(nobb==""?"[right][size=80]-- posted by SilentBot [img]http://forums.xkcd.com/download/file.php?id=47884[/img][/size][/right]":"\n\n-- posted by SilentBot"):""))  >> postfile
	if(id!="")
		print"ID="id >> postfile
	
	print "posted."
	system ("mawk -f "bb2html" -v outfile=\""postfile"\" \""postfile"\"")
	system ("wait 1")
	close (postfile)
}

function urlencode(name,all,   len,iii,escaped,ch)
{
	len=length(name)
	escaped=""
	for(iii=1;iii<=len;++iii)
	{
		ch=substr(name,iii,1);
		if ((ch ~ /[a-zA-Z0-9\.\-_~]/)&&(all==""))
			escaped = escaped ch
		else
			escaped = escaped "%" ch2hex[ch]
	}
	return escaped
}
function hexencode(name,   len,iii,escaped,ch)
{
	len=length(name)
	escaped=""
	for(iii=1;iii<=len;++iii)
	{
		ch=substr(name,iii,1)
		escaped = escaped ch2hex[ch]
	}
	return escaped
}
function subescape(subtext)
{
	gsub(/&/,"\\\\\\&",subtext)
	return subtext
}
	
function htmlescape(name,less,br,   len,iii,escaped,ch)
{
	len=length(name)
	escaped=""
	for(iii=1;iii<=len;++iii)
	{
		ch=substr(name,iii,1);
		if(ch == "\n")
			escaped = escaped ((br!="")?"<br>":"&#"ch2dec[ch]";")
		else if(ch =="\r")
			escaped = escaped ((br!="")?"":"&#"ch2dec[ch]";")
		else if(ch ~ /[\" ]/ && less=="")#"#"\""
			escaped = escaped "&#"ch2dec[ch]";"
		else if(ch ~ /[=<>&]/)
			escaped = escaped "&#"ch2dec[ch]";"
		else
			escaped = escaped ch
	}
	return escaped
}

function getmeme(decree   ,meme,i)
{
	if(decree!="" && lastdecr=="")
	{
		close(tempfile)
		system (automome" -lc 256 -n "memenumber" -d "memepath" -t \"[decr]\" > "tempfile)
	}
	else if(decree=="" && lastdecr!="")
	{
		close(tempfile)
		system (automome" -lc 256 -n "memenumber" -d "memepath" > "tempfile)
	}
	for(i=0;  ((getline meme < tempfile)<=0) && (i<3); ++i)
	{
		memenumber=memenumber*2
		close(tempfile)
		if(decree!="")
			system (automome" -lc 256 -n "memenumber" -d "memepath" -t \"[decr]\" > "tempfile)
		else
			system (automome" -lc 256 -n "memenumber" -d "memepath" > "tempfile)
	}
	lastdecr=decree
	return meme
}

function ong(decree,   line)
{
	while((line=getmeme(decree))!="")
	{
		gsub(/[\r\n]/,"",line)
		if(sub(/[AEIOUY]-N-G/,"#O-N-G#",line)>0)
			return preparebb(line)
		if(sub(/O+N+G+/,"#&#",line)>0)
			return preparebb(line)
		if(sub(/DON'T/,"D#ON'G#T",line)>0)
			return preparebb(line)
		if(sub(/[AEIOUY]NG/,"#ONG#",line)>0)
		{
			if($0!~/TH\[b\]ONG/)
				return preparebb(line)
		}
		if(sub(/ON /,"#ONG# ",line)>0)
			return preparebb(line)
		if(sub(/O\.?$/,"#ONG# ",$0)>0)
			return preparebb(line)
	}
	return "Ong"
}

function ung(decree,   line)
{
	while((line=getmeme(decree))!="")
	{
		gsub(/[\r\n]/,"",line)
		if(sub(/[AEIOUY]-N-G/,"#U-N-G#",line)>0)
			return preparebb(line)
		if(sub(/U+N+G+/,"#&#",line)>0)
			return preparebb(line)
		if(sub(/[AEIOUY]NG/,"#UNG#",line)>0)
			return preparebb(line)
		if(sub(/UN /,"#UNG# ",line)>0)
			return preparebb(line)
		if(sub(/U\.?$/,"#UNG# ",$0)>0)
			return preparebb(line)
	}
	return "Ung"
}
function preparebb(rh)
{
	if(nobb=="")
	{
		gsub(/\*\*/,"¤",rh)
		gsub(/\*[^\*]+\*/,"±&±",rh)
		gsub(/±\*/,"[i]",rh)
		gsub(/\*±/,"[/i]",rh)
		gsub(/¤/,"*",rh)
		
		gsub(/&&/,"¤",rh)
		gsub(/&[^&]+&/,"±&±",rh)
		gsub(/±&/,"[center][b]",rh)
		gsub(/&±/,"[/b][/center]",rh)
		gsub(/¤/,"\\&",rh)
		
		gsub(/__/,"¤",rh)
		gsub(/_[^_]+_/,"±&±",rh)
		gsub(/±_/,"[u]",rh)
		gsub(/_±/,"[/u]",rh)
		gsub(/¤/,"_",rh)
		
		gsub(/##/,"¤",rh)
		gsub(/#[^#]+#/,"±&±",rh)
		gsub(/±#/,"[b]",rh)
		gsub(/#±/,"[/b]",rh)
		gsub(/¤/,"#",rh)
		
		gsub(/\$\$/,"¤",rh)
		gsub(/\$[^\$]+\$/,"±&±",rh)
		gsub(/±\$/,"[size=80]",rh)
		gsub(/\$±/,"[/size]",rh)
		gsub(/¤/,"$",rh)
	}
	
	return rh (nobb==""?" -- [url=http://1190.bicyclesonthemoon.info/ongtext?b=on][b]ong[/b]o[/url][url=http://mrob.com/time/automome/]mome[/url]":" -- ongomome")
}
function unhtml(ht   ,i,j,un,num)
{
	gsub(/<br[ \t]*\/?>/,"[br]",ht)
	while ((i=match(ht, /&#[0-9]+;/))!=0)#
	{
		un=un substr(ht, 1, i-1)
		ht=substr(ht, i)
		j=index(ht, ";")
		num=int(substr(ht, 3, j-3))
		un=un sprintf("%c",num)
		ht=substr(ht, j+1)
	}
	un=un ht
	return un
}
function brescape(text) #there will be more
{
	gsub(/\r/,"",text)
	gsub(/\n/,"[br]",text)
	return text
}
function brunescape(text) #there will be more
{
	gsub(/\[br\]/,"\n",text)
	return text
}
function urldecode(ht   ,i,j,un,num)
# quot, amp, lt, gt, nbsp, and decimal numbered.
{
	while ((i=match(ht, /%[0-9a-fA-F][0-9a-fA-F]/))!=0)#
	{
		un=un substr(ht, 1, i-1)
		ht=substr(ht, i)
		num=toupper(substr(ht, 2, 2))
		un=un hex2ch[num]
		ht=substr(ht, 4)
	}
	un=un ht
	return un
}
function newkey(   key,i,rn)
{
	for(i=0; i<8; ++i)
	{
		rn=int(rand()*65536)
		key = key sprintf("%04X",rn)
	}
	return key
}
